// io require file auto load in node js
var io = require('socket.io-client');

// Enter your API KEY here,
var api_key 			= 'API_KEY'; 

// with Demo API_KEY only EUR/USD, XAU/USD prices are available, if you need more prices, then please enter your API KEY, Signup to get your API KEY.
// Enter your Forex ids, set multiple ids with comma
// get all ids list here  https://fcsapi.com/api/forex/list?type=forex&access_key=API_KEY
var currency_ids 	= '1,1984';

// socket connection start first time
// setTimeout run code after 1 second so we make sure all library are loaded and ready to run 
setTimeout(function(){
	socket_connection();
},1000);

// Variables
var socket_re_conn,socket,heart_interval;

// wss:// if your application does not support WSS/SSL/HTTPS then use "ws://fcsapi.com" (http)
var main_url 		= 'wss://fcsapi.com'; // web socket URL
var backup_url		= 'wss://fxcoinapi.com'; // web socket backup URL
var ws_url 			= main_url; // Web Socket

// Use backup server incase our main server is not accessible
// Note: Only use it for backup.
function backup_server(){
	ws_url = backup_url; // backup URL
	socket_connection();

	// keep try to connect with main server after 5 minute.
	// To test if backup is working for you or not, just use wrong URL in main WebSocket URL
	setTimeout(function(){
		ws_url = main_url;
		socket_connection();
	},5*60*1000); // minute * seconds * 1000
}



// start socket connection function
function socket_connection(){
	// if connection recall, then destroy old if exist. 
	if(socket !== undefined){
		socket.disconnect();
		socket.destroy();
	}

	// require connect with fxpricing
	socket = io.connect(ws_url,{
	    transports: ['websocket']
	});

	// socket heartbeat require once every hour, if your heartbeat stop so you will disconnect
	socket.emit('heartbeat', api_key);
	
	// real time join your ids with FCS
	socket.emit('real_time_join', currency_ids);

	// real time data received 
	socket.on('data_received',function(data){
		var key = Object.keys(data)[0]; // get currency key name e.g: EUR-USD
		var prices_data = Object.values(data)[0]; // get price objects

		// get prices
		console.log(" ------------- NEW ----------- "+key);
		console.log("Currency  : "+key);
		console.log("ASK Price : "+prices_data.ask);
		console.log("BID Price : "+prices_data.bid);
		console.log("Actual Price : "+prices_data.p);
	});

	// real time join on successfully message return
	socket.on('successfully',(message)=>{
		is_connect_to_backup();

		console.log(message);
		console.log("Connect with URL "+ws_url);
		// auto re-connection destroy, when we connect with server
		if(socket_re_conn !== undefined)
			clearTimeout(socket_re_conn);
	});

	// disconnect with message return
	socket.on('disconnect',(message)=>{
		console.log(message);

		// when you'r disconnect,  auto re-connection after 15 minute 
		socket_re_connection();
	});

	// if connection error then connect with backup.
	socket.on('connect_error', function(){
		// On error, socket auto retry to connect, so we will wait 10 seconds before manully connect with backup
		
		try_backup  = setTimeout(backup_server,10000); // conenct with backup server

		console.log('Connection error. If you see this message for more then 15 minutes then contact us. ');
	});

	// heartbeat every hour 
	/* 
		You need to connect with server once per 24 hour, else your connection will be disconnect.
		Below we set heartbeat every hour, you can increase time upto 24 hours, 
		but do not decrease this time, beucase it will slow down your speed with server
	*/
	if(heart_interval !== undefined)
		clearTimeout(heart_interval);

	heart_interval = setInterval(function(){
		socket.emit('heartbeat', api_key);
	}, (1*60*60*1000)); // hour * minutes*seconds*1000; 

}



/* Reconnect if socket disconnect. 
	
	Note: You don't need to decrease re-connect time in setTimeout.
		in case of any socket failure, Socket has its own auto reconnect functionality, so it will quick reconnect with server.
		Below function is extra security, if socket auto reconnect fail, then this function will do its work.
*/
function socket_re_connection(){
	if(socket_re_conn !== undefined)
		clearTimeout(socket_re_conn);

	// keep trying reconnect until connect successfully
	// reconnect after every 15 minute
	socket_re_conn = setTimeout(function(){ 
		socket_connection();
		socket_re_connection();
	}, (15*60*1000));  // minute * seconds * 1000
}


/* Call this Function when you want to disconnect */
function disconnect() {
	if(socket !== undefined && !socket.disconnected){
		socket.disconnect();
		socket.destroy();
	}
	else{
		console.log( "You are not connected with Server");
	}
}


/*
	Clear old pending function, if server connection start auto/manuall
*/
var try_backup;
function is_connect_to_backup(){
	if(try_backup !== undefined)
		clearTimeout(try_backup);
}
